/* add_bd.c */

#include <gtk/gtk.h>
#include <glib.h>
#include <string.h>
#include <stdio.h>
#include "add_bd.h"
#include <dialog.h>


// strings for Board(BD)
#define BD_NEW_WIN_TITLE  "New Board"
#define BD_EDIT_WIN_TITLE "Edit Board"
#define BD_TITLE_LABEL   "Ǽǡ"
#define BD_URL_LABEL     "գң̡"
#define BD_URL_DEFAULT   "http://"
#define BD_NAME_LABEL    "̾"
#define BD_MAIL_LABEL    "᡼롧"
#define BD_CANCEL_BUTTON "󥻥"
#define BD_OK_BUTTON     "OK"

// Error mssages for Alert Dialog
#define BD_NO_TITLE_ERR  "ǼǤ̾ϤƤ\n"
#define BD_NO_URL_ERR    "ǼǤURLϤƤ\n"

void get_strings(GtkWidget*, gpointer);
gint edit_board( gint );

static gchar** new_board;
static GtkWidget *title, *url, *name, *mail;
 
gint add_new_board( gchar** _new_board )
{
   new_board = _new_board;
   return edit_board( (gint)1 );
}

gint edit_old_board( gchar** _old_board )
{
   new_board = _old_board;
   return edit_board( (gint)0 );
}
  
gint edit_board( gint if_new )
{
   GtkWidget       *add_window;
   GtkWidget       *main_vbox, *title_hbox, *url_hbox, *name_hbox,
                   *mail_hbox, *buttons_hbox;
   GtkWidget       *label;
   GtkWidget       *button;

   gint ret = 1;  // 0... all options are OK  -1...cancel button is clicked

   add_window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_widget_set_usize(GTK_WIDGET(add_window), 400, 190);
   if ( if_new )
     gtk_window_set_title(GTK_WINDOW(add_window), BD_NEW_WIN_TITLE);
   else
     gtk_window_set_title(GTK_WINDOW(add_window), BD_EDIT_WIN_TITLE);
   gtk_window_set_policy(GTK_WINDOW(add_window), TRUE, TRUE, FALSE);
   gtk_object_set_user_data( GTK_OBJECT( add_window ), ( (gpointer)-2 ) );
   gtk_signal_connect(GTK_OBJECT(add_window), "delete_event",
		      GTK_SIGNAL_FUNC(get_strings), (gpointer)ret );

   main_vbox=gtk_vbox_new(FALSE, 5);
   gtk_container_border_width(GTK_CONTAINER(main_vbox), 5);
   gtk_container_add(GTK_CONTAINER(add_window), main_vbox);
   gtk_widget_show(main_vbox);

   // Board-title box, label and input-field
   title_hbox = gtk_hbox_new(FALSE, 0);
   gtk_container_border_width(GTK_CONTAINER(title_hbox), 5);
   gtk_box_pack_start(GTK_BOX(main_vbox), title_hbox, TRUE, TRUE, 0);
   gtk_widget_show(title_hbox);
 
   label = gtk_label_new( BD_TITLE_LABEL );
   gtk_box_pack_start(GTK_BOX(title_hbox), label, FALSE, TRUE, 0);
   gtk_widget_show(label);

   title = gtk_entry_new();
   if ( !if_new )
     gtk_entry_set_text(GTK_ENTRY(title), new_board[0] );
   gtk_box_pack_start(GTK_BOX(title_hbox), title, TRUE, TRUE, 0);
   gtk_widget_show(title);

   // URL box, label and input-field        
   url_hbox = gtk_hbox_new(FALSE, 0);
   gtk_container_border_width(GTK_CONTAINER(url_hbox), 5);
   gtk_box_pack_start(GTK_BOX(main_vbox), url_hbox, TRUE, TRUE, 0);
   gtk_widget_show(url_hbox);
 
   label = gtk_label_new( BD_URL_LABEL );
   gtk_box_pack_start(GTK_BOX(url_hbox), label, FALSE, TRUE, 0);
   gtk_widget_show(label);
 
   url = gtk_entry_new();
   if ( if_new )
      gtk_entry_set_text (GTK_ENTRY(url), BD_URL_DEFAULT );
   else
      gtk_entry_set_text (GTK_ENTRY(url), new_board[1] );
   gtk_box_pack_start(GTK_BOX(url_hbox), url, TRUE, TRUE, 0);
   gtk_widget_show(url);
 
   // name box, label and input-field        
   name_hbox = gtk_hbox_new(FALSE, 0);
   gtk_container_border_width(GTK_CONTAINER(name_hbox), 5);
   gtk_box_pack_start(GTK_BOX(main_vbox), name_hbox, TRUE, TRUE, 0);
   gtk_widget_show(name_hbox);  

   label = gtk_label_new( BD_NAME_LABEL );
   gtk_box_pack_start(GTK_BOX(name_hbox), label, FALSE, TRUE, 0);
   gtk_widget_show(label);
 
   name = gtk_entry_new();
   if ( !if_new )
      gtk_entry_set_text (GTK_ENTRY(name), new_board[2] );

   gtk_box_pack_start(GTK_BOX(name_hbox), name, TRUE, TRUE, 0);
   gtk_widget_show(name);  
 
   // mail box, label and input-field        
   mail_hbox = gtk_hbox_new(FALSE, 0);
   gtk_container_border_width(GTK_CONTAINER(mail_hbox), 5);
   gtk_box_pack_start(GTK_BOX(main_vbox), mail_hbox, TRUE, TRUE, 0);
   gtk_widget_show(mail_hbox);

   label = gtk_label_new( BD_MAIL_LABEL );
   gtk_box_pack_start(GTK_BOX(mail_hbox), label, FALSE, TRUE, 0);
   gtk_widget_show(label);

   mail = gtk_entry_new();
   if ( !if_new )
      gtk_entry_set_text (GTK_ENTRY(mail), new_board[3] );
   gtk_box_pack_start(GTK_BOX(mail_hbox), mail, TRUE, TRUE, 0);
   gtk_widget_show(mail);
 
   // buttons box, including two buttons        
   buttons_hbox = gtk_hbutton_box_new();
   gtk_container_border_width(GTK_CONTAINER(buttons_hbox), 5);
   gtk_box_pack_start(GTK_BOX(main_vbox), buttons_hbox, FALSE, FALSE, 0);
   gtk_widget_show(buttons_hbox);

   button = gtk_button_new_with_label ( BD_OK_BUTTON );
   gtk_object_set_user_data( GTK_OBJECT( button ), ( (gpointer)0 ) );
   gtk_signal_connect( GTK_OBJECT( button ), "clicked",
		       GTK_SIGNAL_FUNC(get_strings), (gpointer)&ret );
   gtk_container_add (GTK_CONTAINER (buttons_hbox), button);
   GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
   gtk_widget_grab_default (button);
   gtk_widget_show (button);

   button = gtk_button_new_with_label ( BD_CANCEL_BUTTON );
   gtk_object_set_user_data( GTK_OBJECT( button ), ( (gpointer)-1 ) );
   gtk_signal_connect( GTK_OBJECT( button ), "clicked",
		       GTK_SIGNAL_FUNC(get_strings), (gpointer)&ret );
   gtk_box_pack_start (GTK_BOX (buttons_hbox), button, TRUE, TRUE, 0);
   gtk_widget_show (button);
 
   gtk_widget_show(add_window);

   while( ret == 1 )
      gtk_main_iteration();
       
   gtk_widget_destroy( add_window );
   
   return ret;
}
  
   
void get_strings(GtkWidget *widget, gpointer ret)
{
   gint id = (gint)gtk_object_get_user_data( GTK_OBJECT(widget) );

   if ( id == 0 )
     {
        strcpy( new_board[0], gtk_entry_get_text(GTK_ENTRY(title)) );
	if ( !new_board[0][0] )
	  {
	     alert_dialog(BD_NO_TITLE_ERR, BD_OK_BUTTON, NULL, NULL);
	     // printf( BD_NO_TITLE_ERR );
	     return;
	  }

	strcpy( new_board[1], gtk_entry_get_text(GTK_ENTRY(url)) );
	if ( !new_board[1][0] || !strcmp(new_board[1], BD_URL_DEFAULT) )
	  {
	     alert_dialog(BD_NO_URL_ERR, BD_OK_BUTTON, NULL, NULL);
	     // printf( BD_NO_URL_ERR );
	     return;
	  }
   
	strcpy( new_board[2], gtk_entry_get_text(GTK_ENTRY(name)) );

	strcpy( new_board[3], gtk_entry_get_text(GTK_ENTRY(mail)) );
     }
   *( (int*)ret ) = id;
}
