/* config.c  */

#include <gtk/gtk.h>

#include <stdlib.h>
#include <string.h>
#include "config.h"
#include "add_bd.h"
#include "lib.h"
#include "main.h"
#include "file.h"
#include "dialog.h"

static gint row_num;
static GtkWidget* proxy_button;
static GtkWidget* proxy_name;
static GtkWidget* proxy_port;   
static GtkWidget* clist_tmp;

int config()
{
   gint ret = 1;
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *button_hbox;
   GtkWidget *button;
   GtkWidget *notebook;
   GtkWidget *frame;
   GtkWidget *label;
   GtkWidget *hbox;

   GtkWidget *proxy_vbox;
   GtkWidget *proxy_hbox;
   GSList *group;
   GtkWidget *bd_vbox;
#ifdef GTK_HAVE_FEATURES_1_1_0
   GtkWidget *scrolled_win;
#endif
   
   gint i;
   gchar* tab_name[ 2 ] = { "Ǽ ", "Proxy" };
   gchar* frame_name[ 2 ] = { " ǼǤ ", " Proxy " };
   /* Board */
   gchar           *titles[ 4 ] = { "ȥ", "URL", "̾", "᡼" };

   /* window */
   window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   gtk_window_set_title( GTK_WINDOW(window), "DCUP Configuration" );
   gtk_signal_connect ( GTK_OBJECT (window), "delete_event",
                                GTK_SIGNAL_FUNC(delete_request), (gpointer)&ret );
   gtk_container_border_width ( GTK_CONTAINER (window), 10 );
   gtk_widget_set_usize( window, 630, 350 );
            
   /* vbox */
   vbox = gtk_vbox_new( FALSE, 10 );
   gtk_container_add( GTK_CONTAINER(window), vbox );
   
   /* notebook */
   notebook = gtk_notebook_new();
   gtk_notebook_set_tab_pos ( GTK_NOTEBOOK( notebook ), GTK_POS_TOP );
   gtk_box_pack_start( GTK_BOX( vbox ), notebook, TRUE, TRUE, 0 );
   gtk_widget_show( notebook );
            
   /* append pages to the notebook */
   for ( i=0; i<2; i++ )
     {
	frame = gtk_frame_new( frame_name[ i ] );
	gtk_container_border_width( GTK_CONTAINER( frame ), 10);
        /*  gtk_widget_set_usize( frame, 100, 75 ); */
	gtk_widget_show( frame );

	if ( i == 0 )
	  {
	     bd_vbox = gtk_vbox_new( FALSE, 0 );
	     gtk_container_add( GTK_CONTAINER( frame ), bd_vbox );
	     gtk_widget_show( bd_vbox );
	     clist_tmp = gtk_clist_new_with_titles( 4, titles);
	     row_num = -1;
	     gtk_signal_connect(GTK_OBJECT(clist_tmp), "select_row",
		      (GtkSignalFunc) selection_made, NULL);
	     gtk_signal_connect(GTK_OBJECT(clist_tmp), "unselect_row",
		      (GtkSignalFunc) selection_delete, NULL);
#ifndef GTK_HAVE_FEATURES_1_1_0
	     gtk_clist_set_border(GTK_CLIST(clist_tmp), GTK_SHADOW_OUT);
#else
	     gtk_clist_set_shadow_type(GTK_CLIST(clist_tmp), GTK_SHADOW_OUT);
#endif
	     gtk_clist_set_column_width (GTK_CLIST(clist_tmp), 0, 120);
	     gtk_clist_set_column_width (GTK_CLIST(clist_tmp), 1, 200);
	     gtk_clist_set_column_width (GTK_CLIST(clist_tmp), 2, 100);
	     //   gtk_clist_set_column_width (GTK_CLIST(clist_tmp), 3,  50);

	     copy_clist( clist_tmp, clist );
	     
#ifndef GTK_HAVE_FEATURES_1_1_0
	     gtk_clist_set_policy(GTK_CLIST(clist_tmp), GTK_POLICY_AUTOMATIC,
		     GTK_POLICY_AUTOMATIC);
	     gtk_box_pack_start(GTK_BOX(bd_vbox), clist_tmp, TRUE, TRUE, 10);
#else
	     scrolled_win = gtk_scrolled_window_new (NULL, NULL);
	     //gtk_container_set_border_width (GTK_CONTAINER (scrolled_win), 10);
	     gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
					     GTK_POLICY_AUTOMATIC,
					     GTK_POLICY_AUTOMATIC);
	     gtk_container_add (GTK_CONTAINER (scrolled_win), clist_tmp);
	     gtk_widget_show (clist_tmp);
	     gtk_box_pack_start(GTK_BOX(bd_vbox), scrolled_win, TRUE, TRUE, 10);
	     gtk_widget_show (scrolled_win);
#endif
	     gtk_widget_show(clist_tmp);
	     
	     hbox = gtk_hbox_new(TRUE, 0);
	     gtk_box_pack_start(GTK_BOX(bd_vbox), hbox, FALSE, TRUE, 0);
	     gtk_widget_show(hbox);
	     
	     button = gtk_button_new_with_label("ɲ");
	     gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 10);
	     gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(button_add_clicked), NULL );
	     gtk_widget_show(button);

	     button = gtk_button_new_with_label("Խ");
	     gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 10);
	     gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(button_edit_clicked), NULL);
	     gtk_widget_show(button);

	     button = gtk_button_new_with_label("");
	     gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 10);
	     gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(button_del_clicked), NULL);
	     gtk_widget_show(button);

	     button = gtk_button_new_with_label("ƺ");
	     gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 10);
	     gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(button_clear_clicked), NULL);
	     gtk_widget_show(button);
	  }
	
        else if ( i == 1 )
	  {
	     proxy_vbox = gtk_vbox_new( FALSE, 0 );
	     gtk_container_add( GTK_CONTAINER( frame ), proxy_vbox );
	     gtk_widget_show( proxy_vbox );

	     
	     proxy_button = gtk_radio_button_new_with_label( NULL, "ProxyѤʤ" );
	     gtk_box_pack_start( GTK_BOX( proxy_vbox ), proxy_button, TRUE, TRUE, 15 );
	     gtk_widget_show( proxy_button );
	     
	     group = gtk_radio_button_group( GTK_RADIO_BUTTON( proxy_button ) );
	     proxy_button = gtk_radio_button_new_with_label( group, "ProxyѤ" );
	     if ( use_proxy ) 
	        gtk_toggle_button_set_state( GTK_TOGGLE_BUTTON( proxy_button ), TRUE );
	     gtk_box_pack_start( GTK_BOX( proxy_vbox ), proxy_button, TRUE, TRUE, 0 );
	     gtk_widget_show( proxy_button );

	     proxy_hbox = gtk_hbox_new( FALSE, 0 );
	     // gtk_container_border_width (GTK_CONTAINER (proxy_hbox), 5);
	     gtk_box_pack_start( GTK_BOX( proxy_vbox ), proxy_hbox, TRUE, TRUE, 0 );
	     gtk_widget_show( proxy_hbox );
	     
	     label = gtk_label_new( "̾:" );
	     gtk_box_pack_start( GTK_BOX( proxy_hbox ), label, FALSE, TRUE, 10 );
	     gtk_widget_show( label );
	 
	     proxy_name = gtk_entry_new();
	     if ( proxyserver != NULL && *proxyserver != '\0' )
	        gtk_entry_set_text( GTK_ENTRY( proxy_name ), proxyserver );
	     gtk_box_pack_start( GTK_BOX( proxy_hbox ), proxy_name, TRUE, TRUE, 10 );
	     gtk_widget_show( proxy_name );

	     proxy_hbox = gtk_hbox_new( FALSE, 0 );
	     // gtk_container_border_width (GTK_CONTAINER (proxy_hbox), 5);
	     gtk_box_pack_start( GTK_BOX( proxy_vbox ), proxy_hbox, TRUE, TRUE, 0 );
	     gtk_widget_show( proxy_hbox );
	     
	     label = gtk_label_new( "ݡֹ:" );
	     gtk_box_pack_start( GTK_BOX( proxy_hbox ), label, FALSE, TRUE, 10 );
	     gtk_widget_show( label );
	     
	     proxy_port = gtk_entry_new();
	     if ( proxyport != NULL && *proxyport != '\0' )
	        gtk_entry_set_text( GTK_ENTRY( proxy_port ), proxyport );
	     gtk_box_pack_start( GTK_BOX( proxy_hbox ), proxy_port, TRUE, TRUE, 10 );
	     gtk_widget_show( proxy_port );
	 }

	label = gtk_label_new( tab_name[ i ] );
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), frame, label);
     }

   /* start page NO. */
   gtk_notebook_set_page ( GTK_NOTEBOOK( notebook ), 0 );
            
   gtk_widget_show( vbox );
   

   // button_hbox
   button_hbox = gtk_hbutton_box_new();
   gtk_container_border_width( GTK_CONTAINER(button_hbox), 0 );
   gtk_box_pack_start( GTK_BOX( vbox ), button_hbox, FALSE, FALSE, 0 );
   gtk_widget_show(button_hbox);

   button = gtk_button_new_with_label ( "¸" );
   gtk_object_set_user_data( GTK_OBJECT( button ), ( (gpointer)0 ) );
   gtk_signal_connect( GTK_OBJECT( button ), "clicked",
		      GTK_SIGNAL_FUNC( main_buttons_clicked ), (gpointer)&ret );
   gtk_container_add (GTK_CONTAINER (button_hbox), button);
   GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
   gtk_widget_grab_default (button);
   gtk_widget_show (button);
   
   button = gtk_button_new_with_label ( "󥻥" );
   gtk_object_set_user_data( GTK_OBJECT( button ), ( (gpointer)-1 ) );
   gtk_signal_connect( GTK_OBJECT( button ), "clicked",
		      GTK_SIGNAL_FUNC( main_buttons_clicked ), (gpointer)&ret );
   gtk_box_pack_start (GTK_BOX (button_hbox), button, TRUE, TRUE, 0);
   gtk_widget_show (button);
   
   gtk_widget_show( window );
            
   while( ret == 1 )
     gtk_main_iteration();

   gtk_widget_destroy( window );  

   return ret;
}

/* Add button clicked */
void button_add_clicked( GtkWidget *button, gpointer value)
{
   char* new_bd[4];
   int i;

   for ( i=0; i < 4; i++ )
     new_bd[ i ] = safe_malloc(SHORT_STRING);

   if ( add_new_board( (char**)new_bd ) == 0)
     {
#ifdef DEBUG
	printf("board.c :    new_bd[ ]=%s,%s,%s,%s\n",
	       new_bd[0], new_bd[1],new_bd[2],new_bd[3]);
	printf("board.c :    &new_bd[0]=%X\n", &new_bd[0]);
	printf("board.c :     new_bd[0]=%X\n",  new_bd[0]);
	printf("board.c :     new_bd[0]=%s\n",  new_bd[0]);
#endif
	if ( row_num == -1 )
	  gtk_clist_append( (GtkCList*) clist_tmp, new_bd);
	else
	  gtk_clist_insert( (GtkCList*) clist_tmp, row_num, new_bd);
     }

   for ( i=0; i < 4; i++ )
     safe_free((void **)&new_bd[ i ]);

   return;
}

/* Edit button clicked */
void button_edit_clicked( GtkWidget *button, gpointer value)
{
   gchar* old_bd[4];
   gchar* temp_str;
   gint   row_num_temp = row_num;
   gint i;

   if ( row_num == -1 )
     {
	alert_dialog("Խܤ򤷤Ƥ\n", "OK", NULL, NULL);
     }
   else
     {
	for ( i=0; i<4; i++ )
	  {
	     old_bd[ i ] = safe_malloc(SHORT_STRING);
	  }

	for ( i=0; i<4; i++ )
	  {
	     if ( gtk_clist_get_text(GTK_CLIST(clist_tmp), row_num, i, &temp_str) )
	       strcpy( old_bd[ i ], temp_str );
	     else
	       *old_bd[ i ] = '\0';
	  }

	if ( edit_old_board( (char**)old_bd ) == 0)
	  {
	     gtk_clist_insert( (GtkCList*)clist_tmp, row_num_temp, old_bd);
	     gtk_clist_remove( (GtkCList*)clist_tmp, row_num_temp+1 );
      	  }

	for ( i=0; i < 4; i++ )
	  {
	     safe_free((void **)&old_bd[ i ]);
	  }
     }
   return;
}

/* Del button clicked */
void button_del_clicked( GtkWidget *button, gpointer value)
{

   if ( row_num == -1 )
     alert_dialog( "ܤ򤷤Ƥ\n", "OK", NULL, NULL );
   else
     gtk_clist_remove( (GtkCList*)clist_tmp, row_num );

   return;
}

/* DelAll button clicked */
void button_clear_clicked( GtkWidget *button, gpointer value)
{
   gtk_clist_clear((GtkCList*)clist_tmp);
   return;
}

/* select row */
void selection_made( GtkWidget *clist, gint row, gint column,
		     GdkEventButton *event)
{
   row_num = row;
   return;
}

/* unselect row */
void selection_delete( GtkWidget *clist, gint row, gint column,
		     GdkEventButton *event)
{
   row_num = -1;
   return;
}

/* main button ( Save or Cancel ) clicked */
void main_buttons_clicked( GtkWidget* button, gint* _ret )
{
   gint i = 0;
   gchar* p;

   gint id = (gint)gtk_object_get_user_data( GTK_OBJECT(button) );

   if ( id == 0)  // save button
     {
	if ( GTK_TOGGLE_BUTTON( proxy_button )->active )
	  {
	     use_proxy = 1;
	  }
	else
	  {
	     use_proxy = 0;
	  }

	if ( *(p = gtk_entry_get_text( GTK_ENTRY(proxy_name) )) != '\0' )
	  {
	     safe_free( (void**)&proxyserver );
	     proxyserver = safe_strdup( p );
	  }
	if ( *(p = gtk_entry_get_text( GTK_ENTRY(proxy_port) )) != '\0' )
	  {
	     safe_free( (void**)&proxyport );
	     proxyport = safe_strdup( p );
	  }

	copy_clist( clist, clist_tmp );

	// delete boards (glist) and make new boards
    	g_list_free( boards );
	boards = NULL;
	while ( gtk_clist_get_text( (GtkCList*)clist, i, 0, &p ) )
	  {
	     boards = g_list_append( boards, p );
	     i++;
	  }
        if( boards == NULL )
	  {
	     alert_dialog("ǼǤɲäƤ", "OK", NULL, NULL );
             return;
          }
	gtk_combo_set_popdown_strings( GTK_COMBO( boardcb ), boards );

        // save all parameter to the rc_file
	save_rc();

	*_ret = id;

	return;
     }

   else  // cancel button or ...
     *_ret = id;
}

/* handle for delete event of WM  */
void delete_request( GtkWidget* window, gint* _ret )
{
   *_ret = -2;
}

/* copy board data to another clist */
void copy_clist( GtkWidget* _clist_dest, GtkWidget* _clist_src )
{
   int row = 0;
   int col = 0;
   char* temp = NULL;
   char* null_row[] = { NULL, NULL, NULL, NULL };

   gtk_clist_clear((GtkCList*)_clist_dest);

   while ( gtk_clist_get_text( (GtkCList*)_clist_src, row, 0, &temp ) )
     {
	gtk_clist_append( (GtkCList*)_clist_dest, null_row );
	gtk_clist_set_text( (GtkCList*)_clist_dest, row, 0, temp );

	for ( col=1; col<4; col++ )
	  {
	     if (gtk_clist_get_text( (GtkCList*)_clist_src, row, col, &temp ) == 0 )
		  gtk_clist_set_text( (GtkCList*)_clist_dest, row, col, NULL );
	     else
		  gtk_clist_set_text( (GtkCList*)_clist_dest, row, col, temp );
	  }
	row++;
     }
}
