#include <gtk/gtk.h>
#include "dialog.h"

GtkWidget *entry;
GtkWidget *servername;
GtkWidget *portno;

gint alert_dialog(const char *labelString,
 		  char *button1, 
 		  char *button2, 
 		  char *button3
 		  )
 /* if button1 is clicked, return -1. 
  * if button2 is clicked, return 0.
  * if button3 is clicked, return 1.
  */
 {
   char *defaultbutton = "Ϥ";
   GtkWidget *dialogWindow;
   GtkWidget *label;
   GtkWidget *button;
   gint value;
   int i; 
   char* buttonlabel[3];
   buttonlabel[0] = button1;
   buttonlabel[1] = button2;
   buttonlabel[2] = button3;

   /* Create Dialog Window */
   dialogWindow = gtk_dialog_new();
   gtk_container_border_width (GTK_CONTAINER(GTK_DIALOG(dialogWindow)->vbox),
			       10);

   /* label wo hattuke ru  */
   label = gtk_label_new (labelString);
   gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogWindow)->vbox), label, TRUE,
 		      TRUE, 0);
   gtk_widget_show (label);

   /* button wo hattuke ru */
   if(button1 == NULL && button2 == NULL && button3 == NULL ) {
     button3 = defaultbutton;
   }
   for ( i = 0; i < 3; i++ ) {
     if(buttonlabel[i] != NULL) {
       button = gtk_button_new_with_label(buttonlabel[i]);
       gtk_signal_connect (GTK_OBJECT (button), "clicked",
                           GTK_SIGNAL_FUNC (alert_click), (gpointer)&value);
       gtk_object_set_user_data( GTK_OBJECT(button), (gpointer)(-1+i) );
       gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
 			          GTK_SIGNAL_FUNC (gtk_widget_destroy),
 			          GTK_OBJECT(dialogWindow));
       gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogWindow)->action_area),
			   button, TRUE, TRUE, 0);
       gtk_widget_show (button);
     }
   }
   gtk_widget_show(dialogWindow);

#ifdef MODAL
   gtk_grab_add( dialogWindow );
#endif
   value = 2;
   while ( value == 2 )
     gtk_main_iteration();
#ifdef MODAL
   //gtk_grab_remove( dialogWindow ); //?? Doesn't need ??
#endif
   return value; 
 }

void alert_click (GtkWidget *widget, gpointer value)
 {
   gint id = (gint)gtk_object_get_user_data( GTK_OBJECT(widget) );
   //g_print("button%d is clicked\n", id+2);
   *((gint*)value) = id;
 }

gint entry_dialog(const char *labelString,
 		  char *button1, 
 		  char *button2, 
 		  char *string
 		  )
 /* if button1 is clicked, return -1. 
  * if button2 is clicked, return 0.
  */
 {
   GtkWidget *dialogWindow;
   GtkWidget *label;
   GtkWidget *button;
   struct entrydlg value;
   char* buttonlabel[2];
   buttonlabel[0] = button1;
   buttonlabel[1] = button2;

   /* Create Dialog Window */
   dialogWindow = gtk_dialog_new();
   gtk_container_border_width (GTK_CONTAINER(GTK_DIALOG(dialogWindow)->vbox),
			       10);

   /* label wo hattuke ru  */
   label = gtk_label_new (labelString);
   gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogWindow)->vbox), label, TRUE,
 		      TRUE, 0);
   gtk_widget_show (label);

   entry = gtk_entry_new();
   gtk_entry_set_text (GTK_ENTRY (entry), "http://");
   gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogWindow)->vbox), entry, TRUE,
 		      TRUE, 0);
   gtk_widget_show (entry);

   button = gtk_button_new_with_label(button1!=NULL?button1:"Ϥ");
   gtk_signal_connect (GTK_OBJECT (button), "clicked",
                       GTK_SIGNAL_FUNC (entry_click), (gpointer)&value);
   gtk_object_set_user_data( GTK_OBJECT(button), (gpointer)(-1) );
   gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			      GTK_SIGNAL_FUNC (gtk_widget_destroy),
			      GTK_OBJECT(dialogWindow));
   gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogWindow)->action_area),
		       button, TRUE, TRUE, 0);
   GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
   gtk_widget_grab_default (button);
   gtk_widget_show (button);

   button = gtk_button_new_with_label(button2!=NULL?button2:"");
   gtk_signal_connect (GTK_OBJECT (button), "clicked",
                       GTK_SIGNAL_FUNC (entry_click), (gpointer)&value);
   gtk_object_set_user_data( GTK_OBJECT(button), (gpointer)(0) );
   gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			      GTK_SIGNAL_FUNC (gtk_widget_destroy),
			      GTK_OBJECT(dialogWindow));
   gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogWindow)->action_area),
		       button, TRUE, TRUE, 0);
   gtk_widget_show (button);

   gtk_widget_show(dialogWindow);

#ifdef MODAL
   gtk_grab_add( dialogWindow );
#endif
   value.ret_val = 2;
   value.ret_str = string;
   while ( value.ret_val == 2 )
     gtk_main_iteration();
#ifdef MODAL
   //gtk_grab_remove( dialogWindow ); //?? Doesn't need ??
#endif
   return value.ret_val; 
 }

void entry_click (GtkWidget *widget, gpointer value)
 {
   gint id = (gint)gtk_object_get_user_data( GTK_OBJECT(widget) );
   //g_print("button%d is clicked\n", id+2);
   ((struct entrydlg *)(value))->ret_val = id;
   strcpy(((struct entrydlg *)(value))->ret_str, gtk_entry_get_text(GTK_ENTRY(entry)));
 }

gint proxy_dialog(char *name, 
 		  char *port
		  )
 {
   GtkWidget *dialogWindow;
   GtkWidget *label;
   GtkWidget *button;
   GtkWidget *hbox;
   struct proxydlg value;

   /* Create Dialog Window */
   dialogWindow = gtk_dialog_new();
   gtk_container_border_width (GTK_CONTAINER(GTK_DIALOG(dialogWindow)->vbox),
			       10);

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_container_border_width (GTK_CONTAINER (hbox), 5);
   gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogWindow)->vbox), hbox,
		       TRUE, TRUE, 0);
   gtk_widget_show (hbox);

   label = gtk_label_new("̾");
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 0);
   gtk_widget_show (label);

   servername = gtk_entry_new();
   gtk_entry_set_text (GTK_ENTRY (servername), name);
   gtk_box_pack_start (GTK_BOX (hbox), servername, TRUE, TRUE, 0);
   gtk_widget_show (servername);

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_container_border_width (GTK_CONTAINER (hbox), 5);
   gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogWindow)->vbox), hbox,
		       TRUE, TRUE, 0);
   gtk_widget_show (hbox);

   label = gtk_label_new("ݡֹ桧");
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 0);
   gtk_widget_show (label);

   portno = gtk_entry_new();
   gtk_entry_set_text (GTK_ENTRY (portno), port);
   gtk_box_pack_start (GTK_BOX (hbox), portno, TRUE, TRUE, 0);
   gtk_widget_show (portno);

   button = gtk_button_new_with_label("Ϥ");
   gtk_signal_connect (GTK_OBJECT (button), "clicked",
                       GTK_SIGNAL_FUNC (proxy_click), (gpointer)&value);
   gtk_object_set_user_data( GTK_OBJECT(button), (gpointer)(-1) );
   gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			      GTK_SIGNAL_FUNC (gtk_widget_destroy),
			      GTK_OBJECT(dialogWindow));
   gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogWindow)->action_area),
		       button, TRUE, TRUE, 0);
   GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
   gtk_widget_grab_default (button);
   gtk_widget_show (button);

   button = gtk_button_new_with_label("");
   gtk_signal_connect (GTK_OBJECT (button), "clicked",
                       GTK_SIGNAL_FUNC (proxy_click), (gpointer)&value);
   gtk_object_set_user_data( GTK_OBJECT(button), (gpointer)(0) );
   gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			      GTK_SIGNAL_FUNC (gtk_widget_destroy),
			      GTK_OBJECT(dialogWindow));
   gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogWindow)->action_area),
		       button, TRUE, TRUE, 0);
   gtk_widget_show (button);

   gtk_widget_show(dialogWindow);

#ifdef MODAL
   gtk_grab_add( dialogWindow );
#endif
   value.ret_val = 2;
   value.servername = name;
   value.portno = port;
   while ( value.ret_val == 2 )
     gtk_main_iteration();
#ifdef MODAL
   //gtk_grab_remove( dialogWindow ); //?? Doesn't need ??
#endif
   return value.ret_val; 
 }

void proxy_click (GtkWidget *widget, gpointer value)
 {
   gint id = (gint)gtk_object_get_user_data( GTK_OBJECT(widget) );
   //g_print("button%d is clicked\n", id+2);
   ((struct proxydlg *)(value))->ret_val = id;
   strcpy(((struct proxydlg *)(value))->servername, gtk_entry_get_text(GTK_ENTRY(servername)));
   strcpy(((struct proxydlg *)(value))->portno, gtk_entry_get_text(GTK_ENTRY(portno)));
 }
