/* http.c */

#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <string.h>
#include <unistd.h>

#include "main.h"
#include "http.h"
#include "dialog.h"
#include "lib.h"

int getLine (int fd, char *s, int len)
{
   char ch;
   int bytes = 0;

   while (read (fd, &ch, 1) > 0)
     {
	*s++ = ch;
	bytes++;
	if (ch == '\n')
	  {
	     *s = 0;
	     return (bytes);
	  }
	/* make sure not to overwrite the buffer */
	if (bytes == len - 1)
	  {
	     *s = 0;
	     return bytes;
	  }
     }
   *s = 0;
   return (-1);
}

int post_form (gchar *hosturl,
	       gchar *name,
	       gchar *mail,
	       gchar *title,
	       gchar *url,
	       gchar *content)
{
   struct sockaddr_in sin;
#if SIZEOF_LONG == 4
   long n;
#else
   int n;
#endif
   struct hostent *he;
   unsigned char *host, *cgi, *target, *p;
   unsigned char *temp;
   unsigned char *form_data;
   unsigned char *buffer;
   gint ret_val;
   int length, s;

   s = socket (AF_INET, SOCK_STREAM, IPPROTO_IP);

   memset ((char *) &sin, 0, sizeof(sin));
   sin.sin_family = AF_INET;

   host = safe_malloc(SHORT_STRING);
   cgi = safe_malloc(SHORT_STRING);
   target = safe_malloc(SHORT_STRING);

   // Make a string value host.
   p = strstr(hosturl, "http://");
   strcpy(host, p + strlen("http://"));
   p = strchr(host, '/');
   *p = '\0';

   if (strncmp(host, "www.tcup", strlen("www.tcup")) == 0)
     {
	strcpy(cgi, p+1);
	p = strstr(cgi, ".html");
	if (p != NULL)
	  {
	     *p = '\0';
	     strcat(cgi, ".cgi");
	  }
	if (use_proxy == 0)
	  {
	     sin.sin_port = htons (HTTP_PORT);
	     sprintf(target, "/cgi-localbin/%s", cgi);
	     if ((n = inet_addr (host)) == -1)
	       {
		  /* Must be a DNS name */
		  if ((he = gethostbyname (host)) == NULL)
		    {
		       ret_val = alert_dialog("ǼǤդޤ", "OK",
					      NULL, NULL);
		       safe_free((void **) &host);
		       safe_free((void **) &cgi);
		       safe_free((void **) &target);
		       return(-1);
		    }
		  memcpy ((void *)&sin.sin_addr, *(he->h_addr_list), he->h_length);
	       }
	     else
	       memcpy ((void *)&sin.sin_addr, (void *)&n, sizeof(n));
	  }
	else
	  {
	     sin.sin_port = htons (atoi(proxyport));
	     sprintf(target, "http://%s/cgi-localbin/%s", host, cgi);
	     if ((n = inet_addr (proxyserver)) == -1)
	       {
		  /* Must be a DNS name */
		  if ((he = gethostbyname (proxyserver)) == NULL)
		    {
		       ret_val = alert_dialog("ProxyФդޤ", "OK",
					      NULL, NULL);
		       safe_free((void **) &host);
		       safe_free((void **) &cgi);
		       safe_free((void **) &target);
		       return(-1);
		    }
		  memcpy ((void *)&sin.sin_addr, *(he->h_addr_list), he->h_length);
	       }
	     else
	       memcpy ((void *)&sin.sin_addr, (void *)&n, sizeof(n));
	  }
  
	if (connect (s, (struct sockaddr *) &sin, sizeof (struct sockaddr_in)) == -1)
	  {
	     ret_val = alert_dialog("³˼Ԥޤ", "OK", NULL, NULL);
	     return(-1);
	  }
  
	temp = safe_malloc(HUGE_STRING);
	form_data = safe_malloc(HUGE_STRING*2);
	buffer = safe_malloc(HUGE_STRING*2);

	to_escape(name, temp);
	sprintf(form_data, "action=regist&name=%s", temp);

	if (mail[0])
	  {
	     to_escape(mail, temp);
	     strcat(form_data, "&email=");
	     strcat(form_data, temp);
	  }
	else
	  {
	     strcat(form_data, "&email=");
	  }

	if (title[0])
	  {
	     to_escape(title, temp);
	     strcat(form_data, "&subject=");
	     strcat(form_data, temp);
	  }
	else
	  {
	     strcat(form_data, "&subject=");
	  }
	p = content + strlen(content) - 1;
	if (*p == '\n')
	  {
	     *p = '\0';
	  }
	to_escape(content, temp);
	strcat(form_data, "&value=");
	strcat(form_data, temp);
	if (*url != '\0' && strlen(url) > strlen("http://"))
	  {
	     p = url + strlen(url) - 1;
	     while ( *p == ' ' )
	       p--;
	     *(p+1) = '\0';
	     if (strcmp(url, "http://"))
	       {
		  to_escape(url, temp);
		  strcat(form_data, "&page=");
		  strcat(form_data, temp);
	       }
	  }
	length = strlen(form_data);
     }
   else if (strncmp(host, "kondara.sdri", strlen("kondara.sdri")) == 0)
     {
	strcpy(cgi, p+1);
	p = strstr(cgi, ".html");
	if (p != NULL)
	  {
	     *p = '\0';
	     strcat(cgi, ".cgi");
	  }
	p = strstr(cgi, "bbs");
	if (p != NULL)
	  {
	     *p = '\0';
	     strcpy(target, p + 3);
	     strcat(cgi, "RuBBS");
	     strcat(cgi, target);
	  }
	
	if (use_proxy == 0)
	  {
	     sin.sin_port = htons (HTTP_PORT);
	     sprintf(target, "/%s", cgi);
	     if ((n = inet_addr (host)) == -1)
	       {
		  /* Must be a DNS name */
		  if ((he = gethostbyname (host)) == NULL)
		    {
		       ret_val = alert_dialog("ǼǤդޤ", "OK",
					      NULL, NULL);
		       safe_free((void **) &host);
		       safe_free((void **) &cgi);
		       safe_free((void **) &target);
		       return(-1);
		    }
		  memcpy ((void *)&sin.sin_addr, *(he->h_addr_list), he->h_length);
	       }
	     else
	       memcpy ((void *)&sin.sin_addr, (void *)&n, sizeof(n));
	  }
	else
	  {
	     sin.sin_port = htons (atoi(proxyport));
	     sprintf(target, "http://%s/%s", host, cgi);
	     if ((n = inet_addr (proxyserver)) == -1)
	       {
		  /* Must be a DNS name */
		  if ((he = gethostbyname (proxyserver)) == NULL)
		    {
		       ret_val = alert_dialog("ProxyФդޤ", "OK",
					      NULL, NULL);
		       safe_free((void **) &host);
		       safe_free((void **) &cgi);
		       safe_free((void **) &target);
		       return(-1);
		    }
		  memcpy ((void *)&sin.sin_addr, *(he->h_addr_list), he->h_length);
	       }
	     else
	       memcpy ((void *)&sin.sin_addr, (void *)&n, sizeof(n));
	  }

	if (connect (s, (struct sockaddr *) &sin, sizeof (struct sockaddr_in)) == -1)
	  {
	     ret_val = alert_dialog("³˼Ԥޤ", "OK", NULL, NULL);
	     return(-1);
	  }

	temp = safe_malloc(HUGE_STRING);
	form_data = safe_malloc(HUGE_STRING*2);
	buffer = safe_malloc(HUGE_STRING*2);

	to_escape(name, temp);
	sprintf(form_data, "action=append&name=%s", temp);

	if (mail[0])
	  {
	     to_escape(mail, temp);
	     strcat(form_data, "&mail=");
	     strcat(form_data, temp);
	  }
	else
	  {
	     strcat(form_data, "&mail=");
	  }

	if (title[0])
	  {
	     to_escape(title, temp);
	     strcat(form_data, "&subject=");
	     strcat(form_data, temp);
	  }
	else
	  {
	     strcat(form_data, "&subject=");
	  }
	p = content + strlen(content) - 1;
	if (*p == '\n')
	  {
	     *p = '\0';
	  }
	to_escape(content, temp);
	strcat(form_data, "&contents=");
	strcat(form_data, temp);
	if (*url != '\0' && strlen(url) > strlen("http://"))
	  {
	     p = url + strlen(url) - 1;
	     while ( *p == ' ' )
	       p--;
	     *(p+1) = '\0';
	     if (strcmp(url, "http://"))
	       {
		  to_escape(url, temp);
		  strcat(form_data, "%0D%0A%0D%0A");
		  strcat(form_data, temp);
	       }
	  }
	length = strlen(form_data);
     }
   else if (strncmp(host, "www.aurora", strlen("www.aurora")) == 0)
     {
	p = strchr(p+1, '~');
	if (p != NULL) 
	  {
	     strcpy(cgi, p+1);
	  }
	p = strchr(cgi, '/');
	if (p != NULL)
	  {
	     *p = '\0';
	  }
	
	if (use_proxy == 0)
	  {
	     sin.sin_port = htons (HTTP_PORT);
	     sprintf(target, "/cgi-bin/user/enqV3/%s.cgi", cgi);
	     if ((n = inet_addr (host)) == -1)
	       {
		  /* Must be a DNS name */
		  if ((he = gethostbyname (host)) == NULL)
		    {
		       ret_val = alert_dialog("ǼǤդޤ", "OK",
					      NULL, NULL);
		       safe_free((void **) &host);
		       safe_free((void **) &cgi);
		       safe_free((void **) &target);
		       return(-1);
		    }
		  memcpy ((void *)&sin.sin_addr, *(he->h_addr_list), he->h_length);
	       }
	     else
	       memcpy ((void *)&sin.sin_addr, (void *)&n, sizeof(n));
	  }
	else
	  {
	     sin.sin_port = htons (atoi(proxyport));
	     sprintf(target, "http://%s/cgi-bin/users/enqV3/%s.cgi", host, cgi);
	     if ((n = inet_addr (proxyserver)) == -1)
	       {
		  /* Must be a DNS name */
		  if ((he = gethostbyname (proxyserver)) == NULL)
		    {
		       ret_val = alert_dialog("ProxyФդޤ", "OK",
					      NULL, NULL);
		       safe_free((void **) &host);
		       safe_free((void **) &cgi);
		       safe_free((void **) &target);
		       return(-1);
		    }
		  memcpy ((void *)&sin.sin_addr, *(he->h_addr_list), he->h_length);
	       }
	     else
	       memcpy ((void *)&sin.sin_addr, (void *)&n, sizeof(n));
	  }

	if (connect (s, (struct sockaddr *) &sin, sizeof (struct sockaddr_in)) == -1)
	  {
	     ret_val = alert_dialog("³˼Ԥޤ", "OK", NULL, NULL);
	     return(-1);
	  }

	temp = safe_malloc(HUGE_STRING);
	form_data = safe_malloc(HUGE_STRING*2);
	buffer = safe_malloc(HUGE_STRING*2);

	strcpy(temp, p+1);
	p = strchr(temp, '/');
	if(p != NULL)
	  {
	     *p = '\0';
	  }
	sprintf(buffer, "df=%s/bbs.dat|gb=%s/bbs.conf|dc=%s/dc.conf|ex=%s/field.conf|sp=%s/bbs.html|noesc=y", temp, temp, temp, temp, temp);
	to_escape(buffer, temp);
	sprintf(form_data, "option=%s", temp);

	strcat(form_data, "&name=");
	to_escape(name, temp);
	strcat(form_data, temp);

	if (mail[0])
	  {
	     to_escape(mail, temp);
	     strcat(form_data, "&address=");
	     strcat(form_data, temp);
	  }
	else
	  {
	     strcat(form_data, "&address=");
	  }

	if (title[0])
	  {
	     to_escape(title, temp);
	     strcat(form_data, "&subject=");
	     strcat(form_data, temp);
	  }
	else
	  {
	     strcat(form_data, "&subject=");
	  }
	p = content + strlen(content) - 1;
	if (*p == '\n')
	  {
	     *p = '\0';
	  }
	to_escape(content, temp);
	strcat(form_data, "&body=");
	strcat(form_data, temp);

	if (*url != '\0' && strlen(url) > strlen("http://"))
	  {
	     strcat(form_data, "&url=");
	     to_escape(url, temp);
	     strcat(form_data, temp);
	  }
	length = strlen(form_data);
     }
   else
     {
	strcpy(cgi, p+1);
	p = strstr(cgi, ".html");
	if (p != NULL)
	  {
	     *(p+1) = '\0';
	  }
	if (use_proxy == 0)
	  {
	     sin.sin_port = htons (HTTP_PORT);
	     sprintf(target, "/cgi-bin/%s", cgi);
	     if ((n = inet_addr (host)) == -1)
	       {
		  /* Must be a DNS name */
		  if ((he = gethostbyname (host)) == NULL)
		    {
		       ret_val = alert_dialog("ǼǤդޤ", "OK",
					      NULL, NULL);
		       safe_free((void **) &host);
		       safe_free((void **) &cgi);
		       safe_free((void **) &target);
		       return(-1);
		    }
		  memcpy ((void *)&sin.sin_addr, *(he->h_addr_list), he->h_length);
	       }
	     else
	       memcpy ((void *)&sin.sin_addr, (void *)&n, sizeof(n));
	  }
	else
	  {
	     sin.sin_port = htons (atoi(proxyport));
	     sprintf(target, "http://%s/cgi-bin/%s", host, cgi);
	     if ((n = inet_addr (proxyserver)) == -1)
	       {
		  /* Must be a DNS name */
		  if ((he = gethostbyname (proxyserver)) == NULL)
		    {
		       ret_val = alert_dialog("ProxyФդޤ", "OK",
					      NULL, NULL);
		       safe_free((void **) &host);
		       safe_free((void **) &cgi);
		       safe_free((void **) &target);
		       return(-1);
		    }
		  memcpy ((void *)&sin.sin_addr, *(he->h_addr_list), he->h_length);
	       }
	     else
	       memcpy ((void *)&sin.sin_addr, (void *)&n, sizeof(n));
	  }

	if (connect (s, (struct sockaddr *) &sin, sizeof (struct sockaddr_in)) == -1)
	  {
	     ret_val = alert_dialog("³˼Ԥޤ", "OK", NULL, NULL);
	     return(-1);
	  }
  
	temp = safe_malloc(HUGE_STRING);
	form_data = safe_malloc(HUGE_STRING*2);
	buffer = safe_malloc(HUGE_STRING*2);

	to_escape(name, temp);
	sprintf(form_data, "action=append&name=%s", temp);

	if (mail[0])
	  {
	     to_escape(mail, temp);
	     strcat(form_data, "&mail=");
	     strcat(form_data, temp);
	  }
	else
	  {
	     strcat(form_data, "&mail=");
	  }

	if (title[0])
	  {
	     to_escape(title, temp);
	     strcat(form_data, "&subject=");
	     strcat(form_data, temp);
	  }
	else
	  {
	     strcat(form_data, "&subject=");
	  }
	p = content + strlen(content) - 1;
	if (*p == '\n')
	  {
	     *p = '\0';
	  }
	to_escape(content, temp);
	strcat(form_data, "&contents=");
	strcat(form_data, temp);
	if (*url != '\0' && strlen(url) > strlen("http://"))
	  {
	     p = url + strlen(url) - 1;
	     while ( *p == ' ' )
	       p--;
	     *(p+1) = '\0';
	     if (strcmp(url, "http://"))
	       {
		  to_escape(url, temp);
		  strcat(form_data, "%0D%0A%0D%0A");
		  strcat(form_data, temp);
	       }
	  }
	length = strlen(form_data);
     }

    sprintf(buffer, "POST %s HTTP/1.0\r\n", target);
    sprintf(temp, "Host: %s\r\n", host); 
    strcat(buffer, temp);
    strcat(buffer, "Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, image/png, */*\r\n");
    strcat(buffer, "Accept-Language: en\r\n");
    strcat(buffer, "Pragma: no-cache\r\n");
    strcat(buffer, "Cache-Control: no-cache\r\n");
    strcat(buffer, "User-Agent: DCUP 0.6.1 with Condara\r\n");
    sprintf(temp, "Referer: %s\r\n", hosturl);
    strcat(buffer, temp);
    strcat(buffer, "Content-type: application/x-www-form-urlencoded\r\n");
    sprintf(temp, "Content-length: %d\r\n", length);
    strcat(buffer, temp);
    strcat(buffer, "\r\n");
    strcat(buffer, form_data);

    write (s, buffer, strlen (buffer));

    if (getLine (s, buffer, HUGE_STRING) == -1)
      {
	alert_dialog("˼Ԥޤ", "OK", NULL, NULL);
	ret_val = -1;
      }
    else
      {
	alert_dialog("ޤ", "OK", NULL, NULL);
	ret_val = 0;
      }
    
    safe_free((void **) &host);
    safe_free((void **) &cgi);
    safe_free((void **) &temp);
    safe_free((void **) &form_data);
    safe_free((void **) &buffer);
    
    close (s);
    return (ret_val);
}
