/* lib.h */

#ifndef __LIB_H__
#define __LIB_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define iseuc(c) ((c) >= 0xa1 && (c) <= 0xfe)

#define ACCEPTABLE(a)	( a>=32 && a<128 && ((isAcceptable[a-32]) & 1))
#define HEX_ESCAPE '%'

#ifndef TOASCII
#define TOASCII(c) (c)
#define FROMASCII(c) (c)
#endif /* !TOASCII */

unsigned char jistojms(unsigned char c1, unsigned char c2);
void euctosjis(unsigned char *src, unsigned char *dst);
void to_escape (unsigned char *src, unsigned char *dst);
char *safe_strdup (const char *s);
void *safe_malloc (unsigned int siz);
void safe_realloc (void **p, size_t siz);
void safe_free (void **p);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __LIB_H__ */
