#include <string.h>
#include <stdlib.h>
#include <locale.h>
#include <unistd.h>
#include <errno.h>
#include <pwd.h>
#include <sys/stat.h>
#include <sys/utsname.h>
#include <gtk/gtk.h>
#include "main.h"
#include "menu.h"
#include "text.h"
#include "lib.h"
#include "file.h"

GtkWidget *clist = NULL;
GtkWidget *window = NULL;
GtkWidget *main_vbox = NULL;
GtkWidget *text = NULL;
GtkWidget *namecb = NULL;
GtkWidget *mail = NULL;
GtkWidget *title = NULL;
GtkWidget *url = NULL;
GtkWidget *boardcb = NULL;
GList *boards = NULL;
GList *servers = NULL;
GList *names = NULL;
GList *mails = NULL;
char *gtkrc_path = NULL;
char *dcuprc_path = NULL;
char *proxyserver = NULL;
char *proxyport = NULL;
int use_proxy = 0;

void do_exit (int code)
{
  gtk_widget_destroy (window);
  gtk_main_quit ();
}

int main(int argc, char *argv[])
{
  struct passwd *pw;
  char *p, *path = NULL, *url = NULL;
  GList *lp;

  gtk_set_locale();
  gtk_init(&argc, &argv);

  if ((p = getenv ("HOME")))
    path = safe_strdup(p);

  if (!path)
    if ((pw = getpwuid (getuid ())))
      path = safe_strdup(pw->pw_dir);

  gtkrc_path = safe_malloc(strlen(path) + strlen("/.gtkrc") + 1);
  strcpy(gtkrc_path, path);
  strcat(gtkrc_path, "/.gtkrc");
  gtk_rc_parse(gtkrc_path);

  dcuprc_path = safe_malloc(strlen(path) + strlen("/.dcuprc") + 1);
  strcpy(dcuprc_path, path);
  strcat(dcuprc_path, "/.dcuprc");
  safe_free((void **)&path);

  clist = gtk_clist_new( 4 ); 
   
  load_rc();

  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_signal_connect (GTK_OBJECT (window), "destroy",
		      GTK_SIGNAL_FUNC(do_exit), window);
  gtk_window_set_title(GTK_WINDOW(window), "DCUP");
  gtk_widget_set_usize(GTK_WIDGET(window), 500, 500);
  gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, FALSE);
    
  main_vbox = gtk_vbox_new(FALSE, 0);
  gtk_container_border_width(GTK_CONTAINER(main_vbox), 1);
  gtk_container_add(GTK_CONTAINER(window), main_vbox);
  gtk_widget_show(main_vbox);
    
  init_menu();
  init_text();

  gtk_widget_show(window);
  gtk_main();

  lp = boards; 
  while (lp) 
    {
      safe_free((void **)&(lp->data));
      lp = lp->next;
    }

  lp = servers; 
  while (lp) 
    {
      safe_free((void **)&(lp->data));
      lp = lp->next;
    }

  lp = mails; 
  while (lp) 
    {
      safe_free((void **)&(lp->data));
      lp = lp->next;
    }

  lp = names; 
  while (lp) 
    {
      safe_free((void **)&(lp->data));
      lp = lp->next;
    }

  safe_free((void **)&url);
  safe_free((void **)&proxyport);
  safe_free((void **)&proxyserver);
  safe_free((void **)&gtkrc_path);
  safe_free((void **)&dcuprc_path);

  exit(0);
}
