/* text.c */

#include <gtk/gtk.h>
#include <string.h>
#include "main.h"
#include "text.h"
#include "dialog.h"
#include "http.h"
#include "menu.h"
#include "lib.h"

void board_selected( GtkWidget* widget, GtkWidget *board_entry );


void
init_text()
{
  GtkWidget *box1;
  GtkWidget *box2;
  GtkWidget *box3;
  GtkWidget *hbox;
  GtkWidget *button;
  GtkWidget *table;
  GtkWidget *hscrollbar;
  GtkWidget *vscrollbar;
  GtkWidget *namebox;
  GtkWidget *mailbox;
  GtkWidget *titlebox;
  GtkWidget *serverbox;
  GtkWidget *urlbox;
  GtkWidget *contentbox;
  GtkWidget *label;

  box1 = gtk_vbox_new (FALSE, 0);
  gtk_container_border_width (GTK_CONTAINER (box1), 0);
  gtk_box_pack_start (GTK_BOX (main_vbox), box1, TRUE, TRUE, 0);
  gtk_widget_show (box1);

  box2 = gtk_vbox_new (FALSE, 10);
  gtk_container_border_width (GTK_CONTAINER (box2), 10);
  gtk_box_pack_start (GTK_BOX (box1), box2, TRUE, TRUE, 0);
  gtk_widget_show (box2);

  serverbox = gtk_hbox_new (FALSE, 0);
  gtk_container_border_width (GTK_CONTAINER (serverbox), 0);
  gtk_box_pack_start (GTK_BOX (box2), serverbox, TRUE, TRUE, 0);
  gtk_widget_show (serverbox);

  label = gtk_label_new("񤭹Ǽǡ");
  gtk_box_pack_start (GTK_BOX (serverbox), label, FALSE, TRUE, 0);
  gtk_widget_show (label);

  boardcb = gtk_combo_new ();
  gtk_combo_set_popdown_strings (GTK_COMBO (boardcb), boards);
  gtk_entry_set_editable( GTK_ENTRY(GTK_COMBO(boardcb)->entry), FALSE );
  gtk_signal_connect(GTK_OBJECT(GTK_COMBO(boardcb)->entry), "changed", 
		     GTK_SIGNAL_FUNC(board_selected), GTK_COMBO(boardcb)->entry );

  gtk_box_pack_start (GTK_BOX (serverbox), boardcb, TRUE, TRUE, 0);
  gtk_widget_show (boardcb);

  namebox = gtk_hbox_new (FALSE, 0);
  gtk_container_border_width (GTK_CONTAINER (namebox), 0);
  gtk_box_pack_start (GTK_BOX (box2), namebox, TRUE, TRUE, 0);
  gtk_widget_show (namebox);

  label = gtk_label_new("̾");
  gtk_box_pack_start (GTK_BOX (namebox), label, FALSE, TRUE, 0);
  gtk_widget_show (label);

  namecb = gtk_combo_new ();
  if (names != NULL)
    {
      gtk_combo_set_popdown_strings (GTK_COMBO (namecb), names);
      gtk_entry_set_text (GTK_ENTRY (GTK_COMBO(namecb)->entry),
			  (gchar *)(names->data));
    }
  gtk_box_pack_start (GTK_BOX (namebox), namecb, TRUE, TRUE, 0);
  gtk_widget_show (namecb);

  mailbox = gtk_hbox_new (FALSE, 0);
  gtk_container_border_width (GTK_CONTAINER (mailbox), 0);
  gtk_box_pack_start (GTK_BOX (box2), mailbox, TRUE, TRUE, 0);
  gtk_widget_show (mailbox);

  label = gtk_label_new("᡼롧");
  gtk_box_pack_start (GTK_BOX (mailbox), label, FALSE, TRUE, 0);
  gtk_widget_show (label);

  mail = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (mailbox), mail, TRUE, TRUE, 0);
  gtk_widget_show (mail);

  titlebox = gtk_hbox_new (FALSE, 0);
  gtk_container_border_width (GTK_CONTAINER (titlebox), 0);
  gtk_box_pack_start (GTK_BOX (box2), titlebox, TRUE, TRUE, 0);
  gtk_widget_show (titlebox);

  label = gtk_label_new("̾");
  gtk_box_pack_start (GTK_BOX (titlebox), label, FALSE, TRUE, 0);
  gtk_widget_show (label);

  title = gtk_entry_new ();
  gtk_entry_set_text (GTK_ENTRY (title), "");
  gtk_box_pack_start (GTK_BOX (titlebox), title, TRUE, TRUE, 0);
  gtk_widget_show (title);

  urlbox = gtk_hbox_new (FALSE, 0);
  gtk_container_border_width (GTK_CONTAINER (urlbox), 0);
  gtk_box_pack_start (GTK_BOX (box2), urlbox, TRUE, TRUE, 0);
  gtk_widget_show (urlbox);

  label = gtk_label_new("գң̡");
  gtk_box_pack_start (GTK_BOX (urlbox), label, FALSE, TRUE, 0);
  gtk_widget_show (label);

  url = gtk_entry_new ();
  gtk_entry_set_text (GTK_ENTRY (url), "http://");
  gtk_box_pack_start (GTK_BOX (urlbox), url, TRUE, TRUE, 0);
  gtk_widget_show (url);

  box3 = gtk_vbox_new (FALSE, 10);
  gtk_container_border_width (GTK_CONTAINER (box3), 10);
  gtk_box_pack_start (GTK_BOX (main_vbox), box3, TRUE, TRUE, 0);
  gtk_widget_show (box3);

  contentbox = gtk_hbox_new (FALSE, 0);
  gtk_container_border_width (GTK_CONTAINER (contentbox), 0);
  gtk_box_pack_start (GTK_BOX (box3), contentbox, TRUE, TRUE, 0);
  gtk_widget_show (contentbox);

  label = gtk_label_new("ơʵ̤ޤŬ٤˲Ԥ򤤤Ƥ");
  gtk_box_pack_start (GTK_BOX (contentbox), label, FALSE, TRUE, 0);
  gtk_widget_show (label);

  table = gtk_table_new (2, 2, FALSE);
  gtk_table_set_row_spacing (GTK_TABLE (table), 0, 2);
  gtk_table_set_col_spacing (GTK_TABLE (table), 0, 2);
  gtk_box_pack_start (GTK_BOX (box3), table, TRUE, TRUE, 0);
  gtk_widget_show (table);

  text = gtk_text_new (NULL, NULL);
  gtk_text_set_editable (GTK_TEXT (text), TRUE);
  gtk_table_attach (GTK_TABLE (table), text, 0, 1, 0, 1,
		    GTK_EXPAND | GTK_SHRINK | GTK_FILL,
		    GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_widget_show (text);

  hscrollbar = gtk_hscrollbar_new (GTK_TEXT (text)->hadj);
  gtk_table_attach (GTK_TABLE (table), hscrollbar, 0, 1, 1, 2,
		    GTK_EXPAND | GTK_FILL | GTK_SHRINK, GTK_FILL, 0, 0);
  gtk_widget_show (hscrollbar);

  vscrollbar = gtk_vscrollbar_new (GTK_TEXT (text)->vadj);
  gtk_table_attach (GTK_TABLE (table), vscrollbar, 1, 2, 0, 1,
		    GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_widget_show (vscrollbar);

  gtk_text_freeze (GTK_TEXT (text));
  gtk_widget_realize (text);
  gtk_text_thaw (GTK_TEXT (text));

  hbox = gtk_hbutton_box_new ();
  gtk_container_border_width (GTK_CONTAINER (hbox), 10);
  gtk_box_pack_start (GTK_BOX (main_vbox), hbox, FALSE, FALSE, 0);
  gtk_widget_show (hbox);

  button = gtk_button_new_with_label ("");
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			     GTK_SIGNAL_FUNC(post_message),
			     GTK_OBJECT (window));
  gtk_container_add (GTK_CONTAINER (hbox), button);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (button);
  gtk_widget_show (button);

  button = gtk_button_new_with_label ("õ");
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			     GTK_SIGNAL_FUNC(reset_message),
			     GTK_OBJECT (window));
  gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 0);
  gtk_widget_show (button);

  // set texts to "board","name" and "mail" entry
  gtk_entry_set_text (GTK_ENTRY (GTK_COMBO(boardcb)->entry),
		      (gchar *)(boards->data));
}

void post_message(GtkWidget *widget, gpointer data)
{
  gchar *name_str;
  gchar *mail_str;
  gchar *title_str;
  gchar *url_str;
  gchar *server_str;
  gchar *text_str;
  guint text_len;
  gint ret_val;
  gchar* temp;
  gint row = 0;
   
  text_len = gtk_text_get_length(GTK_TEXT(text));
  text_str = gtk_editable_get_chars(GTK_EDITABLE(text),0,-1);
  if (text_len == 0)
    {
      ret_val = alert_dialog("Ƥޤ", "OK", NULL, NULL);
      return;
    }

  server_str = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(boardcb)->entry));
  while(  gtk_clist_get_text( (GtkCList*)clist, row, 0, &temp ) )
    {
       if( strcmp( temp, server_str ) == 0 )
	 {
	    gtk_clist_get_text( (GtkCList*)clist, row, 1, &server_str );
	    break;
	 }
       row++;
    }

  name_str = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(namecb)->entry));
  if (name_str == NULL || !name_str[0])
    {
      ret_val = alert_dialog("̾ޤ", "OK", NULL, NULL);
      return;
    }

  mail_str = gtk_entry_get_text(GTK_ENTRY(mail));
  if (mail_str[0] && ((char*)strchr(mail_str, '@') == NULL))
    {
      ret_val = alert_dialog("᡼륢ɥ쥹Ǥ", "OK", NULL, NULL);
      return;
    }
  title_str = gtk_entry_get_text(GTK_ENTRY(title));
  url_str = gtk_entry_get_text(GTK_ENTRY(url));

  // send http
  post_form(server_str, name_str, mail_str, title_str, url_str, text_str);
}

void reset_message(GtkWidget *widget, gpointer data)
{
  char* tmp;

  gtk_editable_delete_text(GTK_EDITABLE(text), 0, -1);

  tmp = (char*)safe_strdup((gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(boardcb)->entry))));
  gtk_entry_set_text( GTK_ENTRY(GTK_COMBO(boardcb)->entry), tmp );
   
  gtk_entry_set_text(GTK_ENTRY(title), "");
  gtk_entry_set_text(GTK_ENTRY(url), "http://");
}

// called back when board name is selected from pull-down manu
void board_selected( GtkWidget* widget, GtkWidget *board_entry )
{
   gchar* text;
   gchar* temp;
   gint row = 0;
     
   text = gtk_entry_get_text( GTK_ENTRY(board_entry) );

   // get strings from clist and paste to fields of main window
   while( gtk_clist_get_text( (GtkCList*)clist, row, 0, &temp ) )
     {
	if( strcmp( temp, text ) == 0 )
	  {
	     if ( gtk_clist_get_text( (GtkCList*)clist, row, 2, &temp ) )
	       gtk_entry_set_text( GTK_ENTRY (GTK_COMBO(namecb)->entry), temp );
	     else
	       gtk_entry_set_text( GTK_ENTRY (GTK_COMBO(namecb)->entry), "" );
	     if ( gtk_clist_get_text( (GtkCList*)clist, row, 3, &temp ) )
	       gtk_entry_set_text( GTK_ENTRY( mail ), temp );
	     else
	       gtk_entry_set_text( GTK_ENTRY( mail ), "" );
	     break;
	  }
	row++;
     }
}
	
